// Copyright (C) 2023  Benedikt Zumtobel
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published
// by the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

package pwch

import (
	"database/sql"
	"errors"

	// We are not using any symbols from this package.
	// Just execute the init() function to register with
	// the database/sql package.
	_ "github.com/lib/pq"
)

func connectToDatabase(cfg *Config) (*sql.DB, error) {
	if cfg == nil {
		return nil, errors.New("config is nil")
	}

	connStr := "user=" + cfg.DB.User + " password=" + cfg.DB.Password +
		" dbname=" + cfg.DB.DBName + " host=" + cfg.DB.Host +
		" sslmode=" + cfg.DB.SSLMode

	db, err := sql.Open("postgres", connStr)
	if err != nil {
		return nil, err
	}

	return db, nil
}
